#perl
#ver 1.4 #note : needs symmetry code still.
#author : Seneca Menard
#(10-9-08 fix) : if you're in poly mode, don't have anything selected and accidentally run the script, it won't collapse the entire scene.
#(10-10-08 feature) : there's now a "leaveUVs" feature that will collapse your selection, but not join their uvs.  To use that, run the script with the "leaveUVs" cvar.  ie : "@collapseAverage.pl leaveUVs"
#(12-18-08 fix) : I went and removed the square brackets so that the numbers will always be read as metric units and also because my prior safety check would leave the unit system set to metric system if the script was canceled because changing that preference doesn't get undone if a script is cancelled.

#=================================================
#script arguments :
#=================================================
#leaveUVs : will collapse your selection, but not join their uvs.



my $mainlayer = lxq("query layerservice layers ? main");
if (@ARGV[0] eq "leaveUVs"){
	if( lxq("select.typeFrom {vertex;edge;polygon;item} ?") ){
		collapse("vert");
	}elsif( lxq("select.typeFrom {edge;polygon;item;vertex} ?") ){
		collapse("edge");
	}elsif( lxq("select.typeFrom {polygon;item;vertex;edge} ?") ){
		collapse("poly");
	}else{
		die("You're not in vert, edge, or polygon mode so I'm cancelling the script");
	}
}

elsif( lxq("select.typeFrom {vertex;edge;polygon;item} ?") ){
		lx("!!vert.join [1]");
}

elsif ( lxq("select.typeFrom {polygon;item;vertex;edge} ?") ){
	if (lxq("select.count polygon ?") > 0){lx("!!collapse");}
}

else{
	lx("!!collapse");
}


#collapse subroutine : will collapse selection, but not merge their uvs.
#usage : collapse("poly");
sub collapse{
	my @elems = lxq("query layerservice @_[0]s ? selected");
	lxout("elems = @elems");
	my @avgPos;
	if (@elems > 0){
		foreach my $elem (@elems){
			my @pos = lxq("query layerservice @_[0].pos ? $elem");
			@avgPos[0] += @pos[0];
			@avgPos[1] += @pos[1];
			@avgPos[2] += @pos[2];
		}
		@avgPos[0] /= @elems;
		@avgPos[1] /= @elems;
		@avgPos[2] /= @elems;

		lx("!!vert.move posX:{@avgPos[0]} posY:{@avgPos[1]} posZ:{@avgPos[2]}");
		lx("!!vert.merge auto {0} {1 um}");
	}
}