#perl
#AUTHOR: Seneca Menard
#version 2.0
#This script is for applying edge weighting.  If you don't have a weightmap selected, then it'll select the subd weightmap for you.  If you want the tool to be interactive, then just run the script as usual. If you want the script to set the weight to a specific amount and then turn off the weight tool, just run the script with a numeric argument appended.  ie : "@edgeweight.pl 95"

#arguments :
# any number : If you want the tool to be interactive, then just run the script as usual. If you want the script to set the weight to a specific amount and then turn off the weight tool, just run the script with a numeric argument appended.  ie : "@edgeweight.pl 95" or "@edgeweight.pl 0"


my $mainlayer = lxq("query layerservice layers ? main");
my @weightMaps = lxq("query layerservice vmaps ? weight");
my $weightMapSelected = 0;
my $cvar = "void";
if (@ARGV > 0){$cvar = @ARGV[0];}

foreach my $weightMap (@weightMaps){
	lxout("weightMap = $weightMap");
	if (lxq("query layerservice vmap.selected ? $weightMap") == 1){
		lxout("-There was a weightmap already selected, so I'm keeping it selected");
		$weightMapSelected = 1;
	}
}

#only select "subdivision" if no vmaps are selected.
if ($weightMapSelected == 0){	lx("select.vertexMap Subdivision subd replace");	}

#turn on the weightmap tool
lx("tool.set vertMap.setWeight on");

#if user entered a cvar, apply that specific weighting and turn off the tool.
if ($cvar ne "void"){
	lx("tool.setAttr vertMap.setWeight weight [$cvar %]");
	lx("tool.doApply");
	lx("select.nextMode");
	lx("tool.set vertMap.setWeight off");
}