#perl
#ver 1.4
#author : Seneca Menard
#This script will take all the poly parts 1-100 and save them each out to individual files (and center them on the axis you choose)

#(2-11-10 feature) : the script now lets you skip missing parts
#(2-19-10 feature) : now checks out the files if needed.
#(11-2-10 fix) : fixed a syntax change for 501

#script arguments
foreach my $arg (@ARGV){
	if ($arg =~ /exportLayers/i){	our $exportLayers = 1;	}
}

my $modoVer = lxq("query platformservice appversion ?");
if ($modoVer > 500){our $lwoType = "\$NLWO2";} else {our $lwoType = "\$LWO2";}
my $appendix = quickDialog("File appendix name:",string,"","","");
my $center = quickDialog("Center on which axis:\nX\nY\nZ\nall\nnone",string,"all","","");
while (($center !~ /x/i) && ($center !~ /y/i) && ($center !~ /z/i) && ($center !~ /all/i) && ($center !~ /none/i)){$center = quickDialog("You didn't properly pick one of these:\nCenter on which axis:\nX\nY\nZ\nall",string,"all","","");}
my $axisAlign = quickDialog("Align above or below an axis?\n'' = none\n'X+' = over X axis\n'X-' = under X axis\n'Y+' = over Y axis\n'Y-' = under Y axis\n'Z+' = over Z axis\n'Z+' = under Z axis",string,"","","");

my $sceneIndex = lxq("query sceneservice scene.index ? current");
my $sceneFile = lxq("query sceneservice scene.file ? current");
my $mainlayer = lxq("query layerservice layers ? main");
my $mainlayerID = lxq("query layerservice layer.id ? $mainlayer");
my $layerCount = lxq("query layerservice layer.n ? all");
my $polyCount = lxq("query layerservice poly.n ? visible");
my $textToRemove;
my $check = 0;


for (my $i=1; $i<100; $i++){
	if ($exportLayers == 1){
		my $layer = $i-1;
		if ($layer >= $layerCount){
			last;
			return;
		}
		my $layerID = lxq("query layerservice layer.id ? $i-1");
		lx("select.subItem {$layerID} set mesh;meshInst;camera;light;backdrop;groupLocator;locator;deform;locdeform 0 0") or die("I was unable to select the main layer");
	}else{
		lx("select.drop polygon");
		lx("select.polygon add part face $i");
		our @polySel = lxq("query layerservice polys ? selected");
		our $part = lxq("query layerservice poly.part ? $polySel[-1]");
	}

	if ( ($part != $i) && ($exportLayers != 1) ){
		lxout("$part <> skipping this round $i");
		next;
	}else{
		lx("select.copy");
		lx("scene.new");
		lx("select.paste");
		lx("vert.center $center");
		if ($axisAlign =~ /[xyz]/i){
			my $newMainLayer = lxq("query layerservice layers ? main");
			my @layerBounds = lxq("query layerservice layer.bounds ? $newMainLayer");
			my $axis = 0;
			my $side = 0;
			if		($axisAlign !~ /\+/){$side = 3;}
			if		($axisAlign =~ /y/i){$axis = 1;}
			elsif	($axisAlign =~ /z/i){$axis = 2;}
			my $moveAxis = $axis + $side;
			my $moveDist = -1 * @layerBounds[$moveAxis];

			lx("tool.set actr.auto on");
			lx("tool.set xfrm.move on");
			lx("tool.reset");
			if ($axis == 0)	{lx("tool.setAttr xfrm.move X {$moveDist}");}
			else			{lx("tool.setAttr xfrm.move X 0");}
			if ($axis == 1)	{lx("tool.setAttr xfrm.move Y {$moveDist}");}
			else			{lx("tool.setAttr xfrm.move Y 0");}
			if ($axis == 2)	{lx("tool.setAttr xfrm.move Z {$moveDist}");}
			else			{lx("tool.setAttr xfrm.move Z 0");}
			lx("tool.doApply");
			lx("tool.set xfrm.move off");
		}

		my $newSceneName = $sceneFile;
		$newSceneName =~ s/\.l[wx]o//i;
		my @words = split(/\\/, $newSceneName);

		if ($check == 0){$textToRemove = quickDialog("Delete any text? :\n@words[-1]",string,"","","");}
		if ($textToRemove ne ""){@words[-1] =~ s/$textToRemove//;}
		my $finalSceneName;
		for (my $i=0; $i<$#words; $i++){$finalSceneName .= @words[$i] . "\\";}
		my $count;
		if ($i < 10){$count = "0".$i;}else{$count = $i;}
		$finalSceneName .= @words[-1] . $appendix . "_$count.lwo";
		if ($check == 0){
			popup("Is this the correct filename to use? : $finalSceneName");
			$check = 1;
		}
		if (!-w $finalSceneName){system("p4 edit \"$finalSceneName\"");}
		lx("scene.saveAs {$finalSceneName} {$lwoType} false");
		lx("!!scene.close");
		if (lxq("query sceneservice scene.index ? current") != $sceneIndex){lx("scene.set $sceneIndex");}
		if ($exportLayers != 1){
			lx("select.subItem {$mainlayerID} set mesh;meshInst;camera;light;backdrop;groupLocator;locator;deform;locdeform 0 0") or die("I was unable to select the main layer");
		}
	}
}


#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#QUICK DIALOG SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : quickDialog(username,float,initialValue,min,max);
sub quickDialog{
	if (@_[1] eq "yesNo"){
		lx("dialog.setup yesNo");
		lx("dialog.msg {@_[0]}");
		lx("dialog.open");
		if (lxres != 0){	die("The user hit the cancel button");	}
		return (lxq("dialog.result ?"));
	}else{
		if (lxq("query scriptsysservice userValue.isdefined ? seneTempDialog") == 0){
			lxout("-The seneTempDialog cvar didn't exist so I just created one");
			lx("user.defNew name:[seneTempDialog] life:[temporary]");
		}
		lx("user.def seneTempDialog username [@_[0]]");
		lx("user.def seneTempDialog type [@_[1]]");
		if ((@_[3] != "") && (@_[4] != "")){
			lx("user.def seneTempDialog min [@_[3]]");
			lx("user.def seneTempDialog max [@_[4]]");
		}
		lx("user.value seneTempDialog [@_[2]]");
		lx("user.value seneTempDialog ?");
		if (lxres != 0){	die("The user hit the cancel button");	}
		return(lxq("user.value seneTempDialog ?"));
	}
}

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#POPUP SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : popup("What I wanna print");

sub popup #(MODO2 FIX)
{
	lx("dialog.setup yesNo");
	lx("dialog.msg {@_}");
	lx("dialog.open");
	my $confirm = lxq("dialog.result ?");
	if($confirm eq "no"){die;}
}


