#perl
#ver 1.0
#author : Seneca Menard
#This script will create a 24 bit TGA image and add it to the shader tree.  The reason why I wrote this is because modo's image creator won't let you create rectangular images.

lx("dialog.setup fileSave");
#lx("dialog.fileType tga");
lx("dialog.fileTypeCustom format:[tga] username:[Targa Files] loadPattern:[*.tga] saveExtension:[tga]");
lx("dialog.open");
my $file = lxq("dialog.result ?") or die("The user cancelled the dialog window so I'm cancelling the script");
$file =~ s/\..*/.tga/;
my $size = quickDialog("Image size:",string,"512,512","","");
my @size = split(/,/, $size);
if ((@size[0] > 0) && (@size[1] > 0)){}else{die("It appears you typed in an illegal size.  Please try again");}

my $txLayerCount = lxq("query sceneservice txLayer.n ? all");
my $id;
for (my $i=0; $i<$txLayerCount; $i++){
	if (lxq("query sceneservice txLayer.isSelected ? $i") == 1){
		if (lxq("query sceneservice txLayer.type ? $i") eq "mask"){
			$id = lxq("query sceneservice txLayer.id ? $i");
			last;
		}else{
			my $parent = lxq("query sceneservice txLayer.parent ? $i");
			my $parentType = lxq("query sceneservice txLayer.type ? $parent");
			if (($parentType eq "polyRender") || ($parentType eq "mask")){
				$id = lxq("query sceneservice txLayer.id ? $parent");
				last;
			}
		}
	}
}

if ($id eq ""){
	my $itemCount = lxq("query sceneservice item.N ? all");

	for (my $i=0; $i<$itemCount; $i++){
		my $type = lxq("query sceneservice item.type ? $i");
		if ($type eq "polyRender"){
			$id = lxq("query sceneservice item.id ? $i");
			last;
		}
	}
}

if ($id eq ""){die("I couldn't find which txLayer to parent the new image to so I'm cancelling the script");}
newTGA($file,@size[0],@size[1],24);
lx("texture.new [$file]");
lx("texture.parent [$id] [-1]");






#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#CREATE A NEW TGA TO THE HARD DRIVE
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : newTGA("C://testImage.tga",512,256,24);
sub newTGA{
	#$buf = pack("C", 255);				#for packing 0-255
	#$buf = pack("A*", "Hello World!");	#for packing strings
	#$buf = pack("S", 666);				#for packing unsigned shorts (higher than 255, but not by that much i guess)
	if (@_[3] == ""){die("You can't run the newTGA sub without arguments!");}

	my $file = @_[0];
	my @size = (@_[1],@_[2]);
	my $bitMode = @_[3];

	lxout("[->] Creating a new TGA here : $file");
	open (TGA, ">$file") or die("I can't open the TGA");
	binmode(TGA); #explicitly tells it to be a RAW file

	my $identSize = 		pack("C", 0);
	my $palette = 			pack("C", 0);
	my $imageType = 		pack("C", 2);
	my $colorMapStart = 	pack("S", 0);
	my $colorMapLength = 	pack("S", 0);
	my $colorMapBits =		pack("C", 0);
	my $xStart =			pack("S", 0);
	my $yStart =			pack("S", 0);
	my $width =				pack("S", @size[0]);
	my $height =			pack("S", @size[1]);
	my $bits =				pack("C", $bitMode);
	my $descriptor =		pack("C", 0);
	if ($bitMode == 32){
		our $black =		pack("C4",1,0,0,0);  #note, C4=CCCC. C*=Cinfinite.  also, the read order is backwards, so alpha comes first. lastly, ("CCC",0,0,0) = ("C",0) run three times
	}else{
		our $black =		pack("CCC",0,0,0);
	}


	print TGA $identSize;
	print TGA $palette;
	print TGA $imageType;
	print TGA $colorMapStart;
	print TGA $colorMapLength;
	print TGA $colorMapBits;
	print TGA $xStart;
	print TGA $yStart;
	print TGA $width;
	print TGA $height;
	print TGA $bits;
	print TGA $descriptor;

	for (my $i=0; $i<(@size[0]*@size[1]); $i++){
		print TGA $black;
	}

	close(TGA);
}


#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#POPUP SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : popup("What I wanna print");

sub popup #(MODO2 FIX)
{
	lx("dialog.setup yesNo");
	lx("dialog.msg {@_}");
	lx("dialog.open");
	my $confirm = lxq("dialog.result ?");
	if($confirm eq "no"){die;}
}

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#QUICK DIALOG SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : quickDialog(username,float,initialValue,min,max);
sub quickDialog{
	if (@_[1] eq "yesNo"){
		lx("dialog.setup yesNo");
		lx("dialog.msg {@_[0]}");
		lx("dialog.open");
		if (lxres != 0){	die("The user hit the cancel button");	}
		return (lxq("dialog.result ?"));
	}else{
		if (lxq("query scriptsysservice userValue.isdefined ? seneTempDialog") == 0){
			lxout("-The seneTempDialog cvar didn't exist so I just created one");
			lx("user.defNew name:[seneTempDialog] life:[temporary]");
		}
		lx("user.def seneTempDialog username [@_[0]]");
		lx("user.def seneTempDialog type [@_[1]]");
		if ((@_[3] != "") && (@_[4] != "")){
			lx("user.def seneTempDialog min [@_[3]]");
			lx("user.def seneTempDialog max [@_[4]]");
		}
		lx("user.value seneTempDialog [@_[2]]");
		lx("user.value seneTempDialog ?");
		if (lxres != 0){	die("The user hit the cancel button");	}
		return(lxq("user.value seneTempDialog ?"));
	}
}

