#perl
#ver 0.1
#author : Seneca Menard

#this script is to do miscellaneous modeling things.

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#ARGUMENTS
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
foreach my $arg (@ARGV){
	if		($arg eq "up")		{	our $direction = "up";		}
	elsif	($arg eq "down")	{	our $direction = "down";	}
	elsif	($arg eq "left")	{	our $direction = "left";	}
	elsif	($arg eq "right")	{	our $direction = "right";	}
	elsif	($arg eq "scale")	{	our $scale = 1;				}
}

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#SETUP
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
lxout("eh?");
my $mainlayer = lxq("query layerservice layers ? main");

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#WHICH SUBROUTINES TO RUN
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
if ($scale == 1){
	safetyChecks();
	scale();
	cleanup();
}


#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#SCALE SUBROUTINE
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
sub scale{
	if		(lxq("select.typeFrom {vertex;edge;polygon;item} ?"))	{	our $mode = "vert";		our $selectionMode = "vertex";														}
	elsif	(lxq("select.typeFrom {edge;polygon;item;vertex} ?"))	{	our $mode = "edge";		our $selectionMode = "edge";		lx("select.convert vertex");					}
	elsif	(lxq("select.typeFrom {polygon;item;vertex;edge} ?"))	{	our $mode = "poly";		our $selectionMode = "polygon";														}
	else															{	die("You're not in vertex, edge, or poly mode and so I'm cancelling the script");	}
	my @fewElems;

	if ($selectionMode eq "polygon"){
		my @polys = lxq("query layerservice polys ? selected");
		@fewElems = gatherEveryXElemsFromArray(\@polys,10);
	}else{
		my @verts = lxq("query layerservice verts ? selected");
		@fewElems = gatherEveryXElemsFromArray(\@verts,10);
	}

	my @bboxCenter = (0,0,0);
	foreach my $elem (@fewElems){
		my @pos = lxq("query layerservice $mode.pos ? $elem");
		$bboxCenter[0] += $pos[0];
		$bboxCenter[1] += $pos[1];
		$bboxCenter[2] += $pos[2];
	}
	@bboxCenter = arrMath(@bboxCenter,$#fewElems+1,$#fewElems+1,$#fewElems+1,div);

	if ($direction eq "up")	{	our $scaleAmount = 2;	}
	else					{	our $scaleAmount = .5;	}

	lx("tool.viewType xyz");
	lx("tool.set xfrm.scale on");
	lx("tool.reset");
	lx("tool.attr center.auto cenX {$bboxCenter[0]}");
	lx("tool.attr center.auto cenY {$bboxCenter[1]}");
	lx("tool.attr center.auto cenZ {$bboxCenter[2]}");
	lx("tool.setAttr xfrm.scale factor {$scaleAmount}");
	lx("tool.doApply");
	lx("tool.set xfrm.scale off");
}


#
##------------------------------------------------------------------------------------------------------------
##------------------------------------------------------------------------------------------------------------
##SAFETY CHECKS SUB
##------------------------------------------------------------------------------------------------------------
##------------------------------------------------------------------------------------------------------------
sub safetyChecks{
	#symmetry
	our $symmAxis = lxq("select.symmetryState ?");
	if ($skipSymm != 1){
		if ($symmAxis ne "none"){
			lx("select.symmetryState none");
		}
	}

	#Remember what the workplane was and turn it off
	our @WPmem;
	if ($skypWorkplane != 1){
		@WPmem[0] = lxq ("workPlane.edit cenX:? ");
		@WPmem[1] = lxq ("workPlane.edit cenY:? ");
		@WPmem[2] = lxq ("workPlane.edit cenZ:? ");
		@WPmem[3] = lxq ("workPlane.edit rotX:? ");
		@WPmem[4] = lxq ("workPlane.edit rotY:? ");
		@WPmem[5] = lxq ("workPlane.edit rotZ:? ");
		lx("workPlane.reset ");
	}


	#--------------------------------------------------------------------------------------------------------
	#REMEMBER SELECTION SETTINGS and then set it to selectauto  ((MODO2 FIX))
	#--------------------------------------------------------------------------------------------------------
	#sets the ACTR preset
	our $seltype;
	our $selAxis;
	our $selCenter;
	our $actr = 1;

	if ($skipActr != 1){
		if( lxq( "tool.set actr.select ?") eq "on")				{	$seltype = "actr.select";		}
		elsif( lxq( "tool.set actr.selectauto ?") eq "on")		{	$seltype = "actr.selectauto";	}
		elsif( lxq( "tool.set actr.element ?") eq "on")			{	$seltype = "actr.element";		}
		elsif( lxq( "tool.set actr.screen ?") eq "on")			{	$seltype = "actr.screen";		}
		elsif( lxq( "tool.set actr.origin ?") eq "on")			{	$seltype = "actr.origin";		}
		elsif( lxq( "tool.set actr.local ?") eq "on")			{	$seltype = "actr.local";		}
		elsif( lxq( "tool.set actr.pivot ?") eq "on")			{	$seltype = "actr.pivot";		}
		elsif( lxq( "tool.set actr.auto ?") eq "on")			{	$seltype = "actr.auto";			}
		else
		{
			$actr = 0;
			lxout("custom Action Center");
			if( lxq( "tool.set axis.select ?") eq "on")			{	 $selAxis = "select";			}
			elsif( lxq( "tool.set axis.element ?") eq "on")		{	 $selAxis = "element";			}
			elsif( lxq( "tool.set axis.view ?") eq "on")		{	 $selAxis = "view";				}
			elsif( lxq( "tool.set axis.origin ?") eq "on")		{	 $selAxis = "origin";			}
			elsif( lxq( "tool.set axis.local ?") eq "on")		{	 $selAxis = "local";			}
			elsif( lxq( "tool.set axis.pivot ?") eq "on")		{	 $selAxis = "pivot";			}
			elsif( lxq( "tool.set axis.auto ?") eq "on")		{	 $selAxis = "auto";				}
			else												{	 $actr = 1;  $seltype = "actr.auto"; lxout("You were using an action AXIS that I couldn't read");}

			if( lxq( "tool.set center.select ?") eq "on")		{	 $selCenter = "select";			}
			elsif( lxq( "tool.set center.element ?") eq "on")	{	 $selCenter = "element";		}
			elsif( lxq( "tool.set center.view ?") eq "on")		{	 $selCenter = "view";			}
			elsif( lxq( "tool.set center.origin ?") eq "on")	{	 $selCenter = "origin";			}
			elsif( lxq( "tool.set center.local ?") eq "on")		{	 $selCenter = "local";			}
			elsif( lxq( "tool.set center.pivot ?") eq "on")		{	 $selCenter = "pivot";			}
			elsif( lxq( "tool.set center.auto ?") eq "on")		{	 $selCenter = "auto";			}
			else												{ 	 $actr = 1;  $seltype = "actr.auto"; lxout("You were using an action CENTER that I couldn't read");}
		}
		lx("tool.set actr.auto on");
	}
}

##------------------------------------------------------------------------------------------------------------
##------------------------------------------------------------------------------------------------------------
##CLEANUP SUB
##------------------------------------------------------------------------------------------------------------
##------------------------------------------------------------------------------------------------------------
sub cleanup{
	#symmetry restore
	if ($skipSymm != 1){
		if ($symmAxis ne "none"){
			lxout("turning symm back on ($symmAxis)"); lx("select.symmetryState $symmAxis");
		}
	}

	#Put the workplane back
	if ($skipWorkplane != 1){
		lx("workPlane.edit {@WPmem[0]} {@WPmem[1]} {@WPmem[2]} {@WPmem[3]} {@WPmem[4]} {@WPmem[5]}");
	}

	#Set the action center settings back
	if ($skipActr != 1){
		if ($actr == 1) {	lx( "tool.set {$seltype} on" ); }
		else { lx("tool.set center.$selCenter on"); lx("tool.set axis.$selAxis on"); }
	}

	#restore the last used tool
	#if ($restoreTool == 1) {lx("tool.set $tool on");}

	#restore selection mode (if any)
	if ($selectionMode ne ""){lx("select.type $selectionMode");}
}



#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#PERFORM MATH FROM ONE ARRAY TO ANOTHER subroutine
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : my @disp = arrMath(@pos2,@pos1,subt);
sub arrMath{
	my @array1 = (@_[0],@_[1],@_[2]);
	my @array2 = (@_[3],@_[4],@_[5]);
	my $math = @_[6];

	my @newArray;
	if		($math eq "add")	{	@newArray = (@array1[0]+@array2[0],@array1[1]+@array2[1],@array1[2]+@array2[2]);	}
	elsif	($math eq "subt")	{	@newArray = (@array1[0]-@array2[0],@array1[1]-@array2[1],@array1[2]-@array2[2]);	}
	elsif	($math eq "mult")	{	@newArray = (@array1[0]*@array2[0],@array1[1]*@array2[1],@array1[2]*@array2[2]);	}
	elsif	($math eq "div")	{	@newArray = (@array1[0]/@array2[0],@array1[1]/@array2[1],@array1[2]/@array2[2]);	}
	return @newArray;
}

#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#GATHER EVERY X ELEMS FROM ARRAY
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#usage : my @newArray = gatherEveryXElemsFromArray(\@array,10);  #will return 10 evenly spaced elems from the array
sub gatherEveryXElemsFromArray{
	if (@{$_[0]} < $_[1]){
		return @{$_[0]};
	}else{
		my @newArray;
		for (my $i=0; $i<$_[1]; $i++){
			my $index = 0;
			if ($i > 0)	{	$index = int(@{$_[0]} * (1/$_[1])*$i + .5);	}
			my $arrayValue = @{$_[0]}[$index];
			push(@newArray,@{$_[0]}[$index]);
		}
		return @newArray;
	}
}
