#perl
#ver 1.0
#author : Seneca Menard

#this script is for grouping various parts together so you can create a heirarchy, basically.

#script cvars
foreach my $arg (@ARGV){
	lxout("arg = $arg");
	if		($arg =~ /select/i)	{	our $select = 1;	}
	elsif	($arg =~ /^group/i)	{	our $group = 1;		}
	elsif	($arg =~ /ungroup/i){	our $ungroup = 1;	}
}

my @alphabet = (0,1,2,3,4,5,6,7,8,9,0,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z");
my $mainlayer = lxq("query layerservice layers ? main");
my @polys = lxq("query layerservice polys ? selected");
my %partList;

#determine which subroutine to run
if		($select == 1)	{	&select;	}
elsif	($group == 1)	{	&group;		}
elsif	($ungroup == 1)	{	&ungroup;	}







#===============================================
#SELECT SUBROUTINE
#===============================================
sub select{
	lxout("[->] : select");
	push(@{$partList{lxq("query layerservice poly.part ? $_")}},$_) for @polys;
	my @prefixList;

	foreach my $part (keys %partList){
		if ($part =~ /_/){
			my $partPrefix = $part;
			$partPrefix =~ s/_.*//;
			push(@prefixList,$partPrefix);
		}
	}

	my $partCount = lxq("query layerservice part.n ? all");
	for (my $i=0; $i<$partCount; $i++){
		my $partName = lxq("query layerservice part.name ? $i");
		foreach my $partPrefix (@prefixList){
			my $match = $partPrefix . "_";
			if ($partName =~ $match){
				lxout("yes : $partName");
				lx("!!select.polygon add part face {$partName}");
				last;
			}
		}
	}
}

#===============================================
#UNGROUP SUBROUTINE
#===============================================
sub ungroup{
	lxout("[->] : ungroup");
	push(@{$partList{lxq("query layerservice poly.part ? $_")}},$_) for @polys;

	foreach my $part (keys %partList){
		if ($part !~ /_/){next;}

		my $newPart = $part;
		if ($newPart =~ /_/){$newPart =~ s/.*_//;}
		lx("select.drop polygon");
		lx("select.element $mainlayer polygon add {$_}") for @{$partList{$part}};
		lx("poly.setPart {$newPart}");
	}

	selectOrigPolys();
}

#===============================================
#GROUP SUBROUTINE
#===============================================
sub group{
	lxout("[->] : group");
	my $partPrefix;
	for (my $i=0; $i<6; $i++){$partPrefix .= @alphabet[rand(35)];}
	push(@{$partList{lxq("query layerservice poly.part ? $_")}},$_) for @polys;

	foreach my $part (keys %partList){
		my $newPart = $part;
		lxout("1newPart = $newPart");
		if ($newPart =~ /_/){$newPart =~ s/.*_//;}
		lxout("2newPart = $newPart");
		$newPart = $partPrefix . "_" . $newPart;
		lxout("3newPart = $newPart");

		lx("select.drop polygon");
		lx("select.element $mainlayer polygon add $_") for @{$partList{$part}};
		lx("poly.setPart {$newPart}");
	}

	selectOrigPolys();
}

#===============================================
#SELECT ORIGINAL POLYS SUBROUTINE
#===============================================
sub selectOrigPolys{
	lx("select.drop polygon");
	lx("select.element $mainlayer polygon add $_") for @polys;
}