#perl
#this script is for miscelaneous shader tree commands.  right now there's only the abiliy to tell all the selected images to use the last selected image's txlocator and that's it. (and the txlocators must be selected in the shader tree of course)
lxout("eh");

#SCRIPT ARGUMENTS
foreach my $arg (@ARGV){
	if		($arg =~ /copyPasteTxLocators/i)	{	&copyPasteTxLocators;	}
	elsif	($arg =~ /delUnusedTxLocators/i)	{	&delUnusedTxLocators;	}
	elsif	($arg =~ /st_findReplace/i)			{	&st_findReplace;		}
	elsif	($arg =~ /sel_bySameEffect/i)		{	&sel_bySameEffect;		}
	elsif	($arg =~ /hideSel/i)				{	hide("hideSel");		}
	elsif	($arg =~ /showSel/i)				{	hide("showSel");		}
	elsif	($arg =~ /showAll/i)				{	hide("showAll");		}
	elsif	($arg =~ /showOnlySel/i)			{	hide("showOnlySel");	}
}

sub hide{
	if		($_[0] eq "hideSel")			{	our $hideVal = 0;	}
	elsif	($_[0] eq "showSel")			{	our $hideVal = 1;	}
	elsif	($_[0] eq "showAll")			{	our $hideVal = 2;	}
	elsif	($_[0] eq "showOnlySel")		{	our $hideVal = 3;	}
	else									{	die("no args were submitted, so cancelling script");	}

	my $txLayerCount = lxq("query sceneservice txLayer.n ? all");
	for (my $i=0; $i<$txLayerCount; $i++){
		if ($hideVal == 2){
			my $id = lxq("query sceneservice txLayer.id ? $i");
			lx("shader.setVisible {$id} {1}");
		}elsif ($hideVal == 3){
			my $id = lxq("query sceneservice txLayer.id ? $i");
			if (lxq("query sceneservice txLayer.isSelected ? $i") == 1){
				lx("shader.setVisible {$id} {1}");
			}else{
				lx("shader.setVisible {$id} {0}");
			}
		}elsif (lxq("query sceneservice txLayer.isSelected ? $i") == 1){
			my $id = lxq("query sceneservice txLayer.id ? $i");
			lx("shader.setVisible {$id} {$hideVal}");
		}
	}
}

sub sel_bySameEffect{
	my %itemTypeTable;
		$itemTypeTable{"BaseShader"} = 1;
		$itemTypeTable{"cellular"} = 1;
		$itemTypeTable{"checker"} = 1;
		$itemTypeTable{"constant"} = 1;
		$itemTypeTable{"dots"} = 1;
		$itemTypeTable{"gradient"} = 1;
		$itemTypeTable{"grid"} = 1;
		$itemTypeTable{"imageMap"} = 1;
		$itemTypeTable{"mask"} = 1;
		$itemTypeTable{"noise"} = 1;
		$itemTypeTable{"renderOutput"} = 1;
		$itemTypeTable{"wood"} = 1;

	my $effect = "";
	my @itemSel = lxq("query sceneservice selection ? all");
	foreach my $id (@itemSel){
		if ($itemTypeTable{lxq("query sceneservice item.type ? {$id}")} == 1){
			$effect = lxq("item.channel effect {?} set {$id}");
			last;
		}
	}
	if ($effect eq ""){die("You don't appear to have any shader tree item selected, so I'm cancelling the script");}

	my $txLayerCount = lxq("query sceneservice txLayer.n ? all");
	for (my $i=0; $i<$txLayerCount; $i++){
		my $id = lxq("query sceneservice txLayer.id ? $i");
		if (lxq("item.channel effect {?} set {$id}") eq $effect){
			lx("select.subItem {$id} add textureLayer;render;environment;light;camera");
		}
	}
}


sub st_findReplace{
	my @masks = lxq("query sceneservice selection ? mask");
	my $initialPtag = lxq("item.channel ptag ? set {$masks[0]}");
	my $text_find = quickDialog("text to replace:",string,$initialPtag,"","");
	my $text_replace = quickDialog("replace with this",string,$text_find,"","");

	foreach my $mask (@masks){
		my $ptag = lxq("item.channel ptag ? set {$mask}");
		my $newPtag = $ptag;
		$newPtag =~ s/$text_find/$text_replace/g;
		lxout("ptag = $ptag");
		#popup("result : $ptag : $newPtag");
		lx("material.reassign {$ptag} {$newPtag}");
		lx("select.subItem {$mask} set textureLayer;render;environment;light;camera;mediaClip;txtrLocator");
		lx("!!item.name {} mask");
	}

	lx("select.drop item");
	lx("select.subItem {$_} add textureLayer;render;environment;light;camera;mediaClip;txtrLocator") for @masks;
}

sub copyPasteTxLocators{
	my @txLocators = lxq("query sceneservice selection ? locator");
	if (@txLocators > 1){
		lx("[->] : Assigning all the selected images, the texture locator that the last selected image had");
		my $name = lxq("query sceneservice item.name ? @txLocators[-1]");
		lx("texture.setLocator locator:{$name}");
	}

	#my @selection = lxq("query sceneservice selection ? all");
	#my @foundTextures;
#
	#foreach my $id (@selection){
		#if ((lxq("query sceneservice item.type ? $id") eq "noise")    ||
			#(lxq("query sceneservice item.type ? $id") eq "grid")     ||
			#(lxq("query sceneservice item.type ? $id") eq "gradient") ||
			#(lxq("query sceneservice item.type ? $id") eq "dots")     ||
			#(lxq("query sceneservice item.type ? $id") eq "checker")  ||
			#(lxq("query sceneservice item.type ? $id") eq "imageMap") ||
			#(lxq("query sceneservice item.type ? $id") eq "cellular")){
#
			#push(@foundTextures,$id);
		#}
	#}
#
	#if (@foundTextures < 1){die("You don't have any images or procedural selected, so I can't reassign their texture locators.");}
#
	##lx("select.subItem {@foundTextures[-1]} set textureLayer;render;environment;mediaClip");
	#my $name = lxq("query sceneservice txLayer.name ? @foundTextures[-1]");
	#my $channelCount = lxq("query sceneservice channel.n ?");
	#for (my $i=0; $i<$channelCount; $i++){
		#my $channel = lxq("query sceneservice channel.name ? $i");
		#my $value = lxq("query sceneservice channel.value ? $i");
		#lxout("channel $i = $channel = $value");
	#}
#
	##my $locatorID = lxq("query sceneservice texture.setLocator ? @foundTextures[-1]");
}


#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#QUICK DIALOG SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : quickDialog(username,float,initialValue,min,max);
sub quickDialog{
	if (@_[1] eq "yesNo"){
		lx("dialog.setup yesNo");
		lx("dialog.msg {@_[0]}");
		lx("dialog.open");
		if (lxres != 0){	die("The user hit the cancel button");	}
		return (lxq("dialog.result ?"));
	}else{
		if (lxq("query scriptsysservice userValue.isdefined ? seneTempDialog") == 0){
			lxout("-The seneTempDialog cvar didn't exist so I just created one");
			lx("user.defNew name:[seneTempDialog] life:[temporary]");
		}
		lx("user.def seneTempDialog username [@_[0]]");
		lx("user.def seneTempDialog type [@_[1]]");
		if ((@_[3] != "") && (@_[4] != "")){
			lx("user.def seneTempDialog min [@_[3]]");
			lx("user.def seneTempDialog max [@_[4]]");
		}
		lx("user.value seneTempDialog [@_[2]]");
		lx("user.value seneTempDialog ?");
		if (lxres != 0){	die("The user hit the cancel button");	}
		return(lxq("user.value seneTempDialog ?"));
	}
}

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#POPUP SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : popup("What I wanna print");
sub popup #(MODO2 FIX)
{
	lx("dialog.setup yesNo");
	lx("dialog.msg {@_}");
	lx("dialog.open");
	my $confirm = lxq("dialog.result ?");
	if($confirm eq "no"){die;}
}


