#perl
#TEMP : needs cleanup added.

my $mainlayer = lxq("query layerservice layers ? main");
my @polys = lxq("query layerservice polys ? selected ");
my @edges;
my @verts;
my @borderEdges;
my @softEdges;
my @hardEdges;
my @cutVerts;
my @mergeVerts;
my @deleteVerts;
my $addedVertPolys;

#------------------------------------------------------------------------------------------------------------------------------------------------------
#Find the border edges, ALL verts, and non-border verts
#------------------------------------------------------------------------------------------------------------------------------------------------------
my %verts;
my %edges;
foreach my $poly (@polys){
	my @vertList = lxq("query layerservice poly.vertList ? $poly ");
	for (my $i=0; $i<@vertList; $i++){
		$verts{@vertList[$i]} = 1;
		#fix the edge vert order to stop duplicate edges from being created.
		if (@vertList[$i-1] < @vertList[$i])	{$edges{@vertList[$i-1].",".@vertList[$i]} += 1;}
		else							{$edges{@vertList[$i].",".@vertList[$i-1]} += 1;}
	}
}

#now build the "poly border edge" array and sort 'em out into a vert list.
my %vertList;
foreach my $key (keys %edges){
	if ($edges{$key} == 1){
		push(@edges,$key);
		my @verts = split(/,/, $key);
		$vertList{@verts[0]} = 1;
		$vertList{@verts[1]} = 1;
	}
}

#now find the "extra" verts that are going to lose their vert order when we cut/paste
foreach my $key (keys %verts){
	push(@verts,$key);
	if ($vertList{$key} != 1){
		push(@cutVerts,$key);
	}
}


#------------------------------------------------------------------------------------------------------------------------------------------------------
#Go thru all edges and sort 'em into 3 categories (true border,soft,hard)
#------------------------------------------------------------------------------------------------------------------------------------------------------
foreach my $edge (@edges){
	my @touchPolys = lxq("query layerservice edge.polyList ? ($edge)");
	if (@touchPolys != 1){
		my @normal1 = lxq("query layerservice poly.normal ? @touchPolys[0]");
		my @normal2 = lxq("query layerservice poly.normal ? @touchPolys[1]");
		#popup("$edge\n@touchPolys[0]<>@touchPolys[1]\n@normal1<>@normal2");
		my $dp = ((@normal1[0]*@normal2[0])+(@normal1[1]*@normal2[1])+(@normal1[2]*@normal2[2]));
		#lxout("edge($edge) DP = $dp");

		if ($dp > 0.5){
			lxout("-This edge ($edge) is a SOFT edge ($dp)");
			push(@softEdges,$edge);
		}
		else{
			lxout("-This edge ($edge) is a HARD edge ($dp)");
			push(@hardEdges,$edge);
		}
	}
	else{
		lxout("-This edge ($edge) is a border edge");
		push(@borderEdges,$edge);
	}
}


#------------------------------------------------------------------------------------------------------------------------------------------------------
#Now take all the "true border" edges and sort 'em into edgerows for later use and also to add to the @cutVerts
#------------------------------------------------------------------------------------------------------------------------------------------------------
sortRowStartup(dontFormat,@borderEdges);
foreach my $vertRow (@vertRowList){
	my @verts = split (/[^0-9]/, $vertRow);
	for (my $i=1; $i<$#verts; $i++){
		lxout("adding @verts[$i] to the cutVerts array");
		push(@cutVerts,@verts[$i]);
	}
}


#------------------------------------------------------------------------------------------------------------------------------------------------------
#Now sort all the "hard edge" rows (and overwrite the vertRowList as it's not needed anymore)
#------------------------------------------------------------------------------------------------------------------------------------------------------
sortRowStartup(dontFormat,@hardEdges);


#------------------------------------------------------------------------------------------------------------------------------------------------------
#Cut/paste the polys and fix the vert/edge/poly names.
#------------------------------------------------------------------------------------------------------------------------------------------------------
lx("select.type polygon");
lx("!!select.editSet supertempBLAH add");
lx("select.cut");
#lx("select.invert");
lx("select.paste");
#lx("select.invert");

##TEMP TEMP TEMP
#lx("tool.set xfrm.push on");
#lx("tool.reset");
#lx("tool.setAttr xfrm.push dist [4.6 m]");
#lx("tool.doApply");
#lx("tool.set xfrm.push off");

#run the table building subs
my $vertCount = lxq("query layerservice vert.n ? all");
fixElementTable(\@verts,\@cutVerts);
fixCutPasteNames($vertCount,@verts);



#------------------------------------------------------------------------------------------------------------------------------------------------------
#Now build the polys  (and add the verts that need to be merged to an array)
#------------------------------------------------------------------------------------------------------------------------------------------------------
#SOFT EDGES
foreach my $edge (@softEdges){
	my @verts = split(/,/, $edge);
	my @oldVerts =	($fixElementTable{@verts[0]}, $fixElementTable{@verts[1]});
	my @newVerts =	($fixCutPasteTable{@verts[0]}, $fixCutPasteTable{@verts[1]});

	lx("select.drop vertex");
	lx("select.element $mainlayer vertex add @oldVerts[0]");
	lx("select.element $mainlayer vertex add @oldVerts[1]");
	lx("select.element $mainlayer vertex add @newVerts[1]");
	lx("select.element $mainlayer vertex add @newVerts[0]");
	lx("poly.make face");
}

#HARD EDGES
foreach my $vertRow (@vertRowList){
	my @verts = split (/[^0-9]/, $vertRow);

	#[[-------------------------------------------------------------------------------------------]]
	#move the inner verts (and add to array)
	#[[-------------------------------------------------------------------------------------------]]
	for (my $i=1; $i<$#verts; $i++){
		my $oldVert =	$fixElementTable{@verts[$i]};
		my $newVert =	$fixCutPasteTable{@verts[$i]};

		##TEMP TEMP TEMP!  I shouldn't move the vert because it's not going to be moved thru script!  FUCK.  and vert merging destroys my poly orders!  :(
		#my @newVertPos = lxq("query layerservice vert.pos ? $newVert");
		#lx("select.element $mainlayer vertex set $oldVert");
		#lx("vert.set x @newVertPos[0]");
		#lx("vert.set y @newVertPos[1]");
		#lx("vert.set z @newVertPos[2]");

		#add the new verts to be merged to the merge list.
		push(@mergeVerts,$oldVert,$newVert);
	}

	#[[-------------------------------------------------------------------------------------------]]
	#create the end verts and move 'em.(and add to array)
	#[[-------------------------------------------------------------------------------------------]]
	my $oldVert1 =	$fixElementTable{@verts[0]};
	my $oldVert2 =	$fixElementTable{@verts[1]};
	my $oldVert3 =	$fixElementTable{@verts[-1]};
	my $oldVert4 =	$fixElementTable{@verts[-2]};

	#add the new verts (special case for edgerows with one edge)
	my $vertCount = lxq("query layerservice vert.n ? all");
	if ($oldVert1 == $oldVert4){
		#lxout("This edgerow ($oldVert1,$oldVert3) has only one edge");
		#$addedVertPolyCount += 1;

		addVert($oldVert1,$oldVert2);
		addVert($oldVert2,$vertCount);
	}else{
		#my @edgePolyList1 = lxq("query layerservice edge.polyList ? [($oldVert1,$oldVert2)]");
		#my @edgePolyList2 = lxq("query layerservice edge.polyList ? [($oldVert3,$oldVert4)]");
		#@edgePolyList1 = sort { $a <=> $b } @edgePolyList1;
		#@edgePolyList2 = sort { $a <=> $b } @edgePolyList2;
		#if (@edgePolyList1[0] == @edgePolyList2[0])	{	$addedVertPolyCount += 1;	}
		#else										{	$addedVertPolyCount += 2;	}

		addVert($oldVert1,$oldVert2);
		addVert($oldVert3,$oldVert4);
	}

	#move the verts to their new positions
	my $newVert1 = $fixCutPasteTable{@verts[0]};
	my $newVert2 = $fixCutPasteTable{@verts[-1]};
	my @newVertPos1 = lxq("query layerservice vert.pos ? $newVert1");
	my @newVertPos2 = lxq("query layerservice vert.pos ? $newVert2");

	#TEMP TEMP TEMP TEMP : this part will explode modo if the edgerow's start and end are on the same vert.
	lx("select.element $mainlayer vertex set $vertCount");
	lx("vert.set x @newVertPos1[0]");
	lx("vert.set y @newVertPos1[1]");
	lx("vert.set z @newVertPos1[2]");
	lx("select.element $mainlayer vertex set [$vertCount+1]");
	lx("vert.set x @newVertPos2[0]");
	lx("vert.set y @newVertPos2[1]");
	lx("vert.set z @newVertPos2[2]");

	#check for verts to delete if run on a 1 edgerow edge.
	if ($oldVert1 == $oldVert4){
		my @vertPolyCount1 = lxq("query layerservice vert.polyList ? $oldVert1");
		my @vertPolyCount2 = lxq("query layerservice vert.polyList ? $oldVert3");
		if (@vertPolyCount1 == 1){		push(@deleteVerts,$oldVert1);	}
		if (@vertPolyCount2 == 1){		push(@deleteVerts,$oldVert3);	}
	}

	#add the new verts to be merged to the merge list.
	push(@mergeVerts,$vertCount,$vertCount+1,$newVert1,$newVert2);
	lxout("mergeVerts = @mergeVerts");
	lxout("deleteVerts = @deleteVerts");
}



#------------------------------------------------------------------------------------------------------------------------------------------------------
#Now delete and merge the verts.
#------------------------------------------------------------------------------------------------------------------------------------------------------
lx("select.drop vertex");

#delete the colinear extra verts from the single edgerows.
if (@deleteVerts > 0){
	foreach my $vert(@deleteVerts){	lx("select.element $mainlayer vertex add $vert");	}
	lx("delete");

	@mergeVerts = fixElementList(\@mergeVerts,\@deleteVerts);
}

#now merge all the new vertices
if (@mergeVerts > 0){
	foreach my $vert (@mergeVerts){	lx("select.element $mainlayer vertex add $vert");	}
	lx("!!vert.merge auto [0] [1 um]");
}



#------------------------------------------------------------------------------------------------------------------------------------------------------
#now reselect the original polys
#------------------------------------------------------------------------------------------------------------------------------------------------------
lx("select.drop polygon");
lx("!!select.useSet supertempBLAH select");
lx("!!select.editSet supertempBLAH remove");
lx("tool.set xfrm.move on");


















#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#---------------------------------------------------------------------------SUBROUTINES-----------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ADD VERTEX TO THE MIDDLE OF AN EDGE SUBROUTINE
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub addVert{
	my $poo1 = $mainlayer-1 . "," . @_[0];
	my $poo2 = $mainlayer-1 . "," . @_[1];

	#add the point with edge knife
	lx("tool.set edge.knife on");
	lx("tool.reset");
	lx("tool.attr edge.knife split 0");
	lx("tool.setAttr edge.knife count 1");
	lx("tool.setAttr edge.knife vert0 $poo1");
	lx("tool.setAttr edge.knife vert1 $poo2");
	lx("tool.setAttr edge.knife pos [50.0 %]");
	lx("tool.doApply");
	lx("tool.set edge.knife off");
}

#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#BUILD AN ELEMENT TABLE FOR RENAMING THE VERTS/EDGES THAT HAVE BEEN CUT/PASTED
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub fixCutPasteNames{
	our %fixCutPasteTable = ();
	my @origArray = @_;
	my $totalElemCount = shift(@origArray);
	@origArray  = sort { $a <=> $b } @origArray;
	my @cloneArray = @origArray;

	for (my $i=0; $i<@cloneArray; $i++){
		@cloneArray[-($i+1)] = $totalElemCount - ($i+1);
		$fixCutPasteTable{@origArray[-($i+1)]} = @cloneArray[-($i+1)];
	}
}


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#BUILD AN ELEMENT TABLE FOR RENAMING VERTS/EDGES AFTER SOME HAVE BEEN DELETED
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub fixElementTable{
	our %fixElementTable = ();
	my $array1 = @_[0];
	my $array2 = @_[1];
	my @original = @$array1;
	my @new = @$array1;
	my @deleted = sort { $a <=> $b } @$array2;

	for (my $i=0; $i<@new; $i++){
		my $clone = @new[$i];
		foreach my $deleted (@deleted){
			if		($deleted < $clone)		{ @new[$i]--;	}
			elsif	($deleted >= $clone)	{ last;				}
		}
	}
	lxout("-----------------------------------------------");
	lxout("@deleted\n@original\n@new");
	lxout("-----------------------------------------------");
	for (my $i=0; $i<@original; $i++){
		$fixElementTable{@original[$i]} = @new[$i];
	}
}


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#FIX THE ELEMENT LIST AFTER SOME ELEMENTS HAVE BEEN DELETED.
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub fixElementList{
	my $array1 = @_[0];
	my $array2 = @_[1];
	my @original = @$array1;
	my @deleted = sort { $a <=> $b } @$array2;

	for (my $i=0; $i<@original; $i++){
		my $clone = @original[$i];
		foreach my $deleted (@deleted){
			if		($deleted < $clone)		{ @original[$i]--;	}
			elsif	($deleted >= $clone)	{ last;				}
		}
	}

	return @original;
}


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#REMOVE ARRAY2 FROM ARRAY1 SUBROUTINE
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub removeListFromArray{
	my $array1Copy = @_[0];
	my $array2Copy = @_[1];
	my @fullList = @$array1Copy;
	my @removeList = @$array2Copy;
	for (my $i=0; $i<@removeList; $i++){
		for (my $u=0; $u<@fullList; $u++){
			if (@fullList[$u] eq @removeList[$i]	){
				splice(@fullList, $u,1);
				last;
			}
		}
	}
	return @fullList;
}


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#SORT ROWS SETUP subroutine
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub sortRowStartup{

	#------------------------------------------------------------
	#Import the edge list and format it.
	#------------------------------------------------------------
	my @origEdgeList = @_;
	my $edgeQueryMode = shift(@origEdgeList);
	#------------------------------------------------------------
	#(NO) formatting
	#------------------------------------------------------------
	if ($edgeQueryMode eq "dontFormat"){
		#don't format!
	}
	#------------------------------------------------------------
	#(edges ? selected) formatting
	#------------------------------------------------------------
	elsif ($edgeQueryMode eq "edgesSelected"){
		tr/()//d for @origEdgeList;
	}
	#------------------------------------------------------------
	#(selection ? edge) formatting
	#------------------------------------------------------------
	else{
		my @tempEdgeList;
		foreach my $edge (@origEdgeList){	if ($edge =~ /\($mainlayer/){	push(@tempEdgeList,$edge);		}	}
		#[remove layer info] [remove ( ) ]
		@origEdgeList = @tempEdgeList;
		s/\(\d{0,},/\(/  for @origEdgeList;
		tr/()//d for @origEdgeList;
	}


	#------------------------------------------------------------
	#array creation (after the formatting)
	#------------------------------------------------------------
	our @origEdgeList_edit = @origEdgeList;
	our @vertRow=();
	our @vertRowList=();

	our @vertList=();
	our %vertPosTable=();
	our %endPointVectors=();

	our @vertMergeOrder=();
	our @edgesToRemove=();
	our $removeEdges = 0;


	#------------------------------------------------------------
	#Begin sorting the [edge list] into different [vert rows].
	#------------------------------------------------------------
	while (($#origEdgeList_edit + 1) != 0)
	{
		#this is a loop to go thru and sort the edge loops
		@vertRow = split(/,/, @origEdgeList_edit[0]);
		shift(@origEdgeList_edit);
		&sortRow;

		#take the new edgesort array and add it to the big list of edges.
		push(@vertRowList, "@vertRow");
	}


	#Print out the DONE list   [this should normally go in the sorting sub]
	#lxout("- - -DONE: There are ($#vertRowList+1) edge rows total");
	#for ($i = 0; $i < @vertRowList; $i++) {	lxout("- - -vertRow # ($i) = @vertRowList[$i]"); }
}



#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#SORT ROWS subroutine
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub sortRow
{
	#this first part is stupid.  I need it to loop thru one more time than it will:
	my @loopCount = @origEdgeList_edit;
	unshift (@loopCount,1);

	foreach(@loopCount)
	{
		#lxout("[->] USING sortRow subroutine----------------------------------------------");
		#lxout("original edge list = @origEdgeList");
		#lxout("edited edge list =  @origEdgeList_edit");
		#lxout("vertRow = @vertRow");
		my $i=0;
		foreach my $thisEdge(@origEdgeList_edit)
		{
			#break edge into an array  and remove () chars from array
			@thisEdgeVerts = split(/,/, $thisEdge);
			#lxout("-        origEdgeList_edit[$i] Verts: @thisEdgeVerts");

			if (@vertRow[0] == @thisEdgeVerts[0])
			{
				#lxout("edge $i is touching the vertRow");
				unshift(@vertRow,@thisEdgeVerts[1]);
				splice(@origEdgeList_edit, $i,1);
				last;
			}
			elsif (@vertRow[0] == @thisEdgeVerts[1])
			{
				#lxout("edge $i is touching the vertRow");
				unshift(@vertRow,@thisEdgeVerts[0]);
				splice(@origEdgeList_edit, $i,1);
				last;
			}
			elsif (@vertRow[-1] == @thisEdgeVerts[0])
			{
				#lxout("edge $i is touching the vertRow");
				push(@vertRow,@thisEdgeVerts[1]);
				splice(@origEdgeList_edit, $i,1);
				last;
			}
			elsif (@vertRow[-1] == @thisEdgeVerts[1])
			{
				#lxout("edge $i is touching the vertRow");
				push(@vertRow,@thisEdgeVerts[0]);
				splice(@origEdgeList_edit, $i,1);
				last;
			}
			else
			{
				$i++;
			}
		}
	}
}


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#POPUP subroutine
#------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
sub popup #(MODO2 FIX)
{
	lx("dialog.setup yesNo");
	lx("dialog.msg {@_}");
	lx("dialog.open");
	my $confirm = lxq("dialog.result ?");
	if($confirm eq "no"){die;}
}
