#perl
#ver 0.8
#author : Seneca Menard

#This script is very similar to the extrude in sketchup in that it will only add retaining polys where they're needed.  So if you extrude a poly that has some open edges, those open edges won't

#note : bug that if inner verts of bevelittled polys are lower in value than the old edges, their indices will reduce.
#note : try running it on an island of polys that wouldn't do anything anyways and make sure that works...

my $modoVer = lxq("query platformservice appversion ?");
my $mainlayer = lxq("query layerservice layers ? main");
my %edgeTable;
my @removeEdges;
my @removePolys;
my @polys = lxq("query layerservice polys ? selected");
if (@polys == 0){die("You don't have any polys selected, so i'm cancelling the script");}

#NEW tool preset--------------------------------------------------------
if		(lxq( "tool.set xfrm.move ?") eq "on")			{	our $tool = "xfrm.move";			}
elsif	(lxq("tool.set xfrm.rotate ?") eq "on")			{	our $tool = "xfrm.rotate";			}
elsif 	(lxq("tool.set xfrm.stretch ?") eq "on")		{	our $tool = "xfrm.stretch";			}
elsif 	(lxq("tool.set xfrm.scale ?") eq "on")			{	our $tool = "xfrm.scale";			}
elsif	(lxq("tool.set Transform ?") eq "on")			{	our $tool = "Transform";			}
elsif	(lxq("tool.set TransformMove ?") eq "on")		{	our $tool = "TransformMove";		}
elsif	(lxq("tool.set TransformScale ?") eq "on")		{	our $tool = "TransformScale";		}
elsif	(lxq("tool.set TransformUScale ?") eq "on")		{	our $tool = "TransformUScale";		}
elsif	(lxq("tool.set TransformRotate ?") eq "on")		{	our $tool = "TransformRotate";		}
else													{	our $tool = "TransformMove";		}
#------------------------------------------------------------------------------


lx("select.drop edge");
lx("select.type polygon");
lx("select.boundary");
my @edges = lxq("query layerservice edges ? selected");
foreach my $edge (@edges){
	my $edgeName = $edge;
	$edgeName =~ s/[()]//g;
	#if (@verts[0] < @verts[1])	{$edge = @verts[1].",".@verts[2];	}
	#else						{$edge = @verts[2].",".@verts[1];	}

	my @polyList = lxq("query layerservice edge.polyList ? $edge");
	$edgeTable{$edgeName} = $#polyList+1;

	#if edge connected to 2 polys, check poly angles for edge removal
	if (@polyList == 2){
		my @polyNormal1 = lxq("query layerservice poly.normal ? @polyList[0]");
		my @polyNormal2 = lxq("query layerservice poly.normal ? @polyList[1]");
		my $dp = dotProduct(\@polyNormal1,\@polyNormal2);
		if ($dp < .75){
			push(@removeEdges,$edgeName);
		}
	}
}

lx("select.type polygon");
lx("tool.set poly.extrude on");
lx("tool.reset");
lx("tool.attr poly.extrude mode shift");
lx("tool.attr poly.extrude shiftX {0}");
lx("tool.attr poly.extrude shiftY {0}");
lx("tool.attr poly.extrude shiftZ {0}");
lx("tool.attr poly.extrude segs 1");
lx("tool.doapply");
lx("tool.set poly.extrude off 0");

#now select polys to delete later
foreach my $key (keys %edgeTable){
	if ($edgeTable{$key} == 1){
		my @polyList = lxq("query layerservice edge.polyList ? ($key)");
		lxout("edge=$key <> polys=@polyList");
		push(@removePolys,@polyList[0]);
	}
}
if (@removePolys > 0){
	lx("select.drop polygon");
	popup("removePolys = @removePolys[0]<>@removePolys[1]");
	lx("select.element $mainlayer polygon add $_") for @removePolys;
	#popup("about to delete polys");
	lx("delete");
}

#now remove those edges that needed to be removed
if (@removeEdges > 0){
	lx("select.drop edge");
	foreach my $edge (@removeEdges){
		my @verts = split(/,/, $edge);
		lx("select.element $mainlayer edge add @verts[0] @verts[1]");
	}
	#popup("about to remove edges!");
	lx("!!remove");
}

lx("select.drop polygon");
my $polyCount = lxq("query layerservice poly.n ? all");
for (my $i=$polyCount-@polys; $i<$polyCount; $i++){
	lx("select.element $mainlayer polygon add $i");
}

#turn the move tool back on
lx("tool.set $tool on");
if (($modoVer < 300) && ($tool eq "TransformMove")){
	lx("tool.attr xfrm.transform H translate");
}








#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#DOT PRODUCT subroutine
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : my $dp = dotProduct(\@vector1,\@vector2);
sub dotProduct{
	my @array1 = @{$_[0]};
	my @array2 = @{$_[1]};
	my $dp = (	(@array1[0]*@array2[0])+(@array1[1]*@array2[1])+(@array1[2]*@array2[2])	);
	return $dp;
}


#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#POPUP SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : popup("What I wanna print");
sub popup #(MODO2 FIX)
{
	lx("dialog.setup yesNo");
	lx("dialog.msg {@_}");
	lx("dialog.open");
	my $confirm = lxq("dialog.result ?");
	if($confirm eq "no"){die;}
}
