#perl
#author : Seneca Menard
#ver 1.5
#This script is to snap the selected verts to the grid on the axis you choose.  Just type in the axis you want after the scriptname in the hotkeys.  For example, "@snapToAxis.pl X"
#It can also do 1D, 2D, or 3D snaps if you want, using the axis the current viewport is looking towards the most.  So if you're looking down the Z axis and fire "1D", it'll snap the verts to the Z, if you fire "2D", it'll snap the verts to the two complimentary axes, ie X and Y.  If you fire "3D" it'll snap to all three axes.
#(7-11-08 fix) : fixed a small bug with negative rounding
#(8-1-08 feature) : Added 1D, 2D, or 3D snapping : It snaps the geometry using the axis the current viewport is looking towards the most.  So if you're looking down the Z axis and fire "1D", it'll snap the verts to the Z, if you fire "2D", it'll snap the verts to the two complimentary axes, ie X and Y.  If you fire "3D" it'll snap to all three axes.

#check whether to run the script or not.
if		(lxq( "select.typeFrom {vertex;edge;polygon;item} ?" ) == 1)	{our $selType = "vertex";									}
elsif	(lxq( "select.typeFrom {edge;polygon;item;vertex} ?" ) == 1)	{our $selType = "edge";		lx("select.convert vertex");	}
elsif	(lxq( "select.typeFrom {polygon;item;vertex;edge} ?" ) == 1)	{our $selType = "polygon";	lx("select.convert vertex");	}
elsif	(lxq( "select.typeFrom {item;vertex;edge;polygon} ?" ) == 1)	{our $selType = "item";										}
else{die("\\\\n.\\\\n[---------------------------------------------You're not in vert, edge, polygon or item mode.--------------------------------------------]\\\\n[--PLEASE TURN OFF THIS WARNING WINDOW by clicking on the (In the future) button and choose (Hide Message)--] \\\\n[-----------------------------------This window is not supposed to come up, but I can't control that.---------------------------]\\\\n.\\\\n");}


if ($selType eq "item"){
	itemSnap();
}else{
	vertSnap();
}



sub itemSnap{ #TEMP : need to move over the grid calc stuff to a central location.
	#my %itemTypes;
		#$itemTypes{"mesh"} = 1;
		#$itemTypes{"meshInst"} = 1;
		#$itemTypes{"triSurf"} = 1;
		#$itemTypes{"groupLocator"} = 1;
		#$itemTypes{"locator"} = 1;
		#$itemTypes{"camera"} = 1;
		#$itemTypes{"sunLight"} = 1;
		#$itemTypes{"pointLight"} = 1;
		#$itemTypes{"spotLight"} = 1;
		#$itemTypes{"photometryLight"} = 1;
		#$itemTypes{"domeLight"} = 1;
		#$itemTypes{"cylinderLight"} = 1;
		#$itemTypes{"areaLight"} = 1;
#
	#my @selection = lxq("query sceneservice selection ? item");
	#foreach my $item (@selection){
		#my $type = lxq("query sceneservice item.type ? $item");
		#if ($itemTypes{$type] == 1){
			#my @pos = (
				#item.channel pos.X [?] set {$item} ,
				#item.channel pos.Y [?] set {$item} ,
				#item.channel pos.Z [?] set {$item} ,
			#);
#
#
		#}
	#}
}

sub vertSnap{
	#setup
	my $mainlayer = lxq("query layerservice layers ? main");
	my @axisSetup;
	my @vertPos = (0,0,0);
	my @newVertPos = (0,0,0);
	my $primaryAxis;
	if (lxq("pref.value units.system ?") eq "game")	{	our $power = 2;	}
	else											{	our $power = 10;}

	#NEW tool preset--------------------------------------------------------
	if		(lxq( "tool.set xfrm.move ?") eq "on")			{	our $tool = "xfrm.move";			}
	elsif	(lxq("tool.set xfrm.rotate ?") eq "on")			{	our $tool = "xfrm.rotate";			}
	elsif 	(lxq("tool.set xfrm.stretch ?") eq "on")		{	our $tool = "xfrm.stretch";			}
	elsif 	(lxq("tool.set xfrm.scale ?") eq "on")			{	our $tool = "xfrm.scale";			}
	elsif	(lxq("tool.set Transform ?") eq "on")			{	our $tool = "Transform";			}
	elsif	(lxq("tool.set TransformMove ?") eq "on")		{	our $tool = "TransformMove";		}
	elsif	(lxq("tool.set TransformScale ?") eq "on")		{	our $tool = "TransformScale";		}
	elsif	(lxq("tool.set TransformUScale ?") eq "on")		{	our $tool = "TransformUScale";		}
	elsif	(lxq("tool.set TransformRotate ?") eq "on")		{	our $tool = "TransformRotate";		}
	else													{	our $tool = "none";					}
	#------------------------------------------------------------------------------


	#find grid size
	my $view = lxq("query view3dservice mouse.view ?");
	my @axis = lxq("query view3dservice view.axis ? $view");
	my @frame = lxq("query view3dservice view.frame ?");
	my $scale = lxq("query view3dservice view.scale ? $view");
	my @viewBbox = lxq("query view3dservice view.rect ? $view");
	my @viewScale = (($scale * @viewBbox[2]),($scale * @viewBbox[3]));
	my @div = ((@viewScale[0]/16),(@viewScale[1]/16));
	my $log = int(.55 + (log(@div[0])/log($power)));
	my $grid = $power ** $log;

	#find primary axis
	my @xAxis = (1,0,0);
	my @yAxis = (0,1,0);
	my @zAxis = (0,0,1);
	my $dp0 = dotProduct(\@axis,\@xAxis);
	my $dp1 = dotProduct(\@axis,\@yAxis);
	my $dp2 = dotProduct(\@axis,\@zAxis);
	if 		((abs($dp0) >= abs($dp1)) && (abs($dp0) >= abs($dp2)))	{	$primaryAxis = 0;	lxout("[->] : Using world X axis");}
	elsif	((abs($dp1) >= abs($dp0)) && (abs($dp1) >= abs($dp2)))	{	$primaryAxis = 1;	lxout("[->] : Using world Y axis");}
	else															{	$primaryAxis = 2;	lxout("[->] : Using world Z axis");}

	#determine which axes to move the verts on.
	if (@ARGV[0] =~ /d/i){
		if 		(@ARGV[0] =~ /1d/i)	{@axisSetup = (0,0,0);		@axisSetup[$primaryAxis] = 1;	}
		elsif	(@ARGV[0] =~ /2d/i)	{@axisSetup = (1,1,1);		@axisSetup[$primaryAxis] = 0;	}
		elsif	(@ARGV[0] =~ /3d/i)	{@axisSetup = (1,1,1);										}
		else	{die("You must type in a '1D', '2D', '3D', or 'X', 'Y', 'Z' for me to know which axes you want to snap the verts to the grid on");}
	}else{
		if 		(@ARGV[0] =~ /x/i)	{@axisSetup = (1,0,0);}
		elsif 	(@ARGV[0] =~ /y/i)	{@axisSetup = (0,1,0);}
		elsif 	(@ARGV[0] =~ /z/i)	{@axisSetup = (0,0,1);}
		else	{die("You must type in a '1D', '2D', '3D', or 'X', 'Y', 'Z' for me to know which axes you want to snap the verts to the grid on");}
	}


	#move the verts
	my @verts = lxq("query layerservice verts ? selected");
	foreach my $vert (@verts){
		@vertPos = lxq("query layerservice vert.pos ? $vert");

		for (my $i=0; $i<@newVertPos; $i++){
			if (@axisSetup[$i] == 1){
				my $div = @vertPos[$i] / $grid;
				@newVertPos[$i] = int(0.5 + abs($div)) * $grid;
				if (@vertPos[$i] < 0){@newVertPos[$i] *= -1;}
			}else{
				@newVertPos[$i] = @vertPos[$i];
			}
		}

		lx("vert.move vertIndex:$vert posX:{@newVertPos[0]} posY:{@newVertPos[1]} posZ:{@newVertPos[2]}");
	}

	#cleanup
	lx("select.type $selType");
	#uses the new tool preset-------------------------------------------
	if ($tool ne "none"){
		lx("tool.set $tool on");
		if (($modoVer < 300) && ($tool eq "TransformMove")){
			lx("tool.attr xfrm.transform H translate");
		}
	}
	#------------------------------------------------------------------------------
}






#=====================================================================================================================================
#=====================================================================================================================================
#=====================================================================================================================================
#=====================================================================================================================================
#===														SUBROUTINES			    											  ====
#=====================================================================================================================================
#=====================================================================================================================================
#=====================================================================================================================================
#=====================================================================================================================================

#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#DOT PRODUCT subroutine
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : my $dp = dotProduct(\@vector1,\@vector2);
sub dotProduct{
	my @array1 = @{$_[0]};
	my @array2 = @{$_[1]};
	my $dp = (	(@array1[0]*@array2[0])+(@array1[1]*@array2[1])+(@array1[2]*@array2[2])	);
	return $dp;
}


#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#POPUP SUB
#------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------
#USAGE : popup("What I wanna print");

sub popup #(MODO2 FIX)
{
	lx("dialog.setup yesNo");
	lx("dialog.msg {@_}");
	lx("dialog.open");
	my $confirm = lxq("dialog.result ?");
	if($confirm eq "no"){die;}
}

